# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.case_timeline import CaseTimeline
from unicourt.model.sos_data_preview import SOSDataPreview
from typing import Optional, Set
from typing_extensions import Self

class AssociatedNormParty(BaseModel):
    """
    AssociatedNormParty
    """ # noqa: E501
    object: Optional[Annotated[str, Field(strict=True, max_length=19)]] = 'AssociatedNormParty'
    norm_party_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, alias="normPartyId")
    norm_party_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Link to Details for the Party.", alias="normPartyAPI")
    case_timeline: Optional[CaseTimeline] = Field(default=None, alias="caseTimeline")
    name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = None
    case_search_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Link to related cases for this association.", alias="caseSearchAPI")
    case_count: Optional[StrictInt] = Field(default=None, alias="caseCount")
    sos_data_array: Optional[List[SOSDataPreview]] = Field(default=None, alias="sosDataArray")
    __properties: ClassVar[List[str]] = ["object", "normPartyId", "normPartyAPI", "caseTimeline", "name", "caseSearchAPI", "caseCount", "sosDataArray"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssociatedNormParty from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of case_timeline
        if self.case_timeline:
            _dict['caseTimeline'] = self.case_timeline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in sos_data_array (list)
        _items = []
        if self.sos_data_array:
            for _item in self.sos_data_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sosDataArray'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssociatedNormParty from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'AssociatedNormParty',
            "normPartyId": obj.get("normPartyId"),
            "normPartyAPI": obj.get("normPartyAPI"),
            "caseTimeline": CaseTimeline.from_dict(obj["caseTimeline"]) if obj.get("caseTimeline") is not None else None,
            "name": obj.get("name"),
            "caseSearchAPI": obj.get("caseSearchAPI"),
            "caseCount": obj.get("caseCount"),
            "sosDataArray": [SOSDataPreview.from_dict(_item) for _item in obj["sosDataArray"]] if obj.get("sosDataArray") is not None else None
        })
        return _obj


