# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.contact import Contact
from typing import Optional, Set
from typing_extensions import Self

class AssociatedSoSPerson(BaseModel):
    """
    AssociatedSoSPerson
    """ # noqa: E501
    object: Optional[Annotated[str, Field(strict=True, max_length=19)]] = 'AssociatedSoSPerson'
    contact: Optional[Contact] = None
    entity_name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, alias="entityName")
    entity_type: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, alias="entityType")
    __properties: ClassVar[List[str]] = ["object", "contact", "entityName", "entityType"]

    @field_validator('entity_type')
    def entity_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Partner', 'Agent', 'CEO', 'Partner/General Member', 'Partner/GeneralMember']):
            raise ValueError("must be one of enum values ('Partner', 'Agent', 'CEO', 'Partner/General Member', 'Partner/GeneralMember')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssociatedSoSPerson from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contact
        if self.contact:
            _dict['contact'] = self.contact.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssociatedSoSPerson from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'AssociatedSoSPerson',
            "contact": Contact.from_dict(obj["contact"]) if obj.get("contact") is not None else None,
            "entityName": obj.get("entityName"),
            "entityType": obj.get("entityType")
        })
        return _obj


