# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.cause_of_action import CauseOfAction
from unicourt.model.cause_of_action_additional_data import CauseOfActionAdditionalData
from typing import Optional, Set
from typing_extensions import Self

class CaseCauseOfAction(BaseModel):
    """
    CaseCauseOfAction
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=17, strict=True, max_length=17)]] = Field(default='CaseCauseOfAction', description="Name of the object")
    cause_of_action: Optional[CauseOfAction] = Field(default=None, alias="causeOfAction")
    cause_of_action_additional_data_array: Optional[List[CauseOfActionAdditionalData]] = Field(default=None, alias="causeOfActionAdditionalDataArray")
    __properties: ClassVar[List[str]] = ["object", "causeOfAction", "causeOfActionAdditionalDataArray"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CaseCauseOfAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cause_of_action
        if self.cause_of_action:
            _dict['causeOfAction'] = self.cause_of_action.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in cause_of_action_additional_data_array (list)
        _items = []
        if self.cause_of_action_additional_data_array:
            for _item in self.cause_of_action_additional_data_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['causeOfActionAdditionalDataArray'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CaseCauseOfAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'CaseCauseOfAction',
            "causeOfAction": CauseOfAction.from_dict(obj["causeOfAction"]) if obj.get("causeOfAction") is not None else None,
            "causeOfActionAdditionalDataArray": [CauseOfActionAdditionalData.from_dict(_item) for _item in obj["causeOfActionAdditionalDataArray"]] if obj.get("causeOfActionAdditionalDataArray") is not None else None
        })
        return _obj


