# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.case_document import CaseDocument
from unicourt.model.exception import Exception
from unicourt.model.export_file import ExportFile
from typing import Optional, Set
from typing_extensions import Self

class CaseDocumentOrderCallback(BaseModel):
    """
    CaseDocumentOrderCallback
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=25, strict=True, max_length=25)]] = Field(default='CaseDocumentOrderCallback', description="Name of the object.")
    case_document_order_callback_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, description="Unique Id for the Case Document Order Callback.", alias="caseDocumentOrderCallbackId")
    case_document_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, description="UniCourt's Case Document ID.", alias="caseDocumentId")
    callback_generated_date: Optional[datetime] = Field(default=None, description="Date when the job is run.", alias="callbackGeneratedDate")
    status: Optional[Annotated[str, Field(min_length=7, strict=True, max_length=11)]] = Field(default=None, description="Status of the request.")
    case_document: Optional[CaseDocument] = Field(default=None, alias="caseDocument")
    case_document_order_callback_api: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1024)]] = Field(default=None, alias="caseDocumentOrderCallbackAPI")
    file: Optional[ExportFile] = None
    exception: Optional[Exception] = None
    __properties: ClassVar[List[str]] = ["object", "caseDocumentOrderCallbackId", "caseDocumentId", "callbackGeneratedDate", "status", "caseDocument", "caseDocumentOrderCallbackAPI", "file", "exception"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['COMPLETE', 'FAILURE', 'IN_PROGRESS', 'DELAYED']):
            raise ValueError("must be one of enum values ('COMPLETE', 'FAILURE', 'IN_PROGRESS', 'DELAYED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CaseDocumentOrderCallback from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of case_document
        if self.case_document:
            _dict['caseDocument'] = self.case_document.to_dict()
        # override the default output from pydantic by calling `to_dict()` of file
        if self.file:
            _dict['file'] = self.file.to_dict()
        # override the default output from pydantic by calling `to_dict()` of exception
        if self.exception:
            _dict['exception'] = self.exception.to_dict()
        # set to None if callback_generated_date (nullable) is None
        # and model_fields_set contains the field
        if self.callback_generated_date is None and "callback_generated_date" in self.model_fields_set:
            _dict['callbackGeneratedDate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CaseDocumentOrderCallback from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'CaseDocumentOrderCallback',
            "caseDocumentOrderCallbackId": obj.get("caseDocumentOrderCallbackId"),
            "caseDocumentId": obj.get("caseDocumentId"),
            "callbackGeneratedDate": obj.get("callbackGeneratedDate"),
            "status": obj.get("status"),
            "caseDocument": CaseDocument.from_dict(obj["caseDocument"]) if obj.get("caseDocument") is not None else None,
            "caseDocumentOrderCallbackAPI": obj.get("caseDocumentOrderCallbackAPI"),
            "file": ExportFile.from_dict(obj["file"]) if obj.get("file") is not None else None,
            "exception": Exception.from_dict(obj["exception"]) if obj.get("exception") is not None else None
        })
        return _obj


