# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.source_structured_data import SourceStructuredData
from typing import Optional, Set
from typing_extensions import Self

class Hearing(BaseModel):
    """
    Hearing
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=7, strict=True, max_length=7)]] = Field(default='Hearing', description="Name of the object")
    hearing_date: Optional[datetime] = Field(default=None, description="Hearing Date", alias="hearingDate")
    hearing_description: Optional[StrictStr] = Field(default=None, description="Source Hearing Description Text", alias="hearingDescription")
    hearing_structured: Optional[SourceStructuredData] = Field(default=None, alias="hearingStructured")
    location: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(default=None, description="Location where the hearing will takeplace.")
    first_fetch_date: Optional[Annotated[str, Field(min_length=25, strict=True, max_length=25)]] = Field(default=None, description="When this hearing was first fetched from the source.", alias="firstFetchDate")
    last_fetch_date: Optional[Annotated[str, Field(min_length=25, strict=True, max_length=25)]] = Field(default=None, description="When this hearing was last fetched from the source.", alias="lastFetchDate")
    __properties: ClassVar[List[str]] = ["object", "hearingDate", "hearingDescription", "hearingStructured", "location", "firstFetchDate", "lastFetchDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Hearing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of hearing_structured
        if self.hearing_structured:
            _dict['hearingStructured'] = self.hearing_structured.to_dict()
        # set to None if hearing_description (nullable) is None
        # and model_fields_set contains the field
        if self.hearing_description is None and "hearing_description" in self.model_fields_set:
            _dict['hearingDescription'] = None

        # set to None if location (nullable) is None
        # and model_fields_set contains the field
        if self.location is None and "location" in self.model_fields_set:
            _dict['location'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Hearing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'Hearing',
            "hearingDate": obj.get("hearingDate"),
            "hearingDescription": obj.get("hearingDescription"),
            "hearingStructured": SourceStructuredData.from_dict(obj["hearingStructured"]) if obj.get("hearingStructured") is not None else None,
            "location": obj.get("location"),
            "firstFetchDate": obj.get("firstFetchDate"),
            "lastFetchDate": obj.get("lastFetchDate")
        })
        return _obj


