# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class LawFirmAnalyticsAPI(BaseModel):
    """
    LawFirmAnalyticsAPI
    """ # noqa: E501
    object: Optional[Annotated[str, Field(strict=True, max_length=19)]] = 'LawFirmAnalyticsAPI'
    norm_law_firm_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Link to Details for the Law Firm.", alias="normLawFirmAPI")
    associated_norm_attorney_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="associatedNormAttorneyAPI")
    associated_norm_judge_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="associatedNormJudgeAPI")
    associated_norm_parties_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="associatedNormPartiesAPI")
    case_count_analytics_by_opposing_norm_attorney_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="caseCountAnalyticsByOpposingNormAttorneyAPI")
    case_count_analytics_by_opposing_norm_law_firm_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="caseCountAnalyticsByOpposingNormLawFirmAPI")
    case_count_analytics_by_opposing_norm_party_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="caseCountAnalyticsByOpposingNormPartyAPI")
    __properties: ClassVar[List[str]] = ["object", "normLawFirmAPI", "associatedNormAttorneyAPI", "associatedNormJudgeAPI", "associatedNormPartiesAPI", "caseCountAnalyticsByOpposingNormAttorneyAPI", "caseCountAnalyticsByOpposingNormLawFirmAPI", "caseCountAnalyticsByOpposingNormPartyAPI"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LawFirmAnalyticsAPI from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if case_count_analytics_by_opposing_norm_attorney_api (nullable) is None
        # and model_fields_set contains the field
        if self.case_count_analytics_by_opposing_norm_attorney_api is None and "case_count_analytics_by_opposing_norm_attorney_api" in self.model_fields_set:
            _dict['caseCountAnalyticsByOpposingNormAttorneyAPI'] = None

        # set to None if case_count_analytics_by_opposing_norm_party_api (nullable) is None
        # and model_fields_set contains the field
        if self.case_count_analytics_by_opposing_norm_party_api is None and "case_count_analytics_by_opposing_norm_party_api" in self.model_fields_set:
            _dict['caseCountAnalyticsByOpposingNormPartyAPI'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LawFirmAnalyticsAPI from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'LawFirmAnalyticsAPI',
            "normLawFirmAPI": obj.get("normLawFirmAPI"),
            "associatedNormAttorneyAPI": obj.get("associatedNormAttorneyAPI"),
            "associatedNormJudgeAPI": obj.get("associatedNormJudgeAPI"),
            "associatedNormPartiesAPI": obj.get("associatedNormPartiesAPI"),
            "caseCountAnalyticsByOpposingNormAttorneyAPI": obj.get("caseCountAnalyticsByOpposingNormAttorneyAPI"),
            "caseCountAnalyticsByOpposingNormLawFirmAPI": obj.get("caseCountAnalyticsByOpposingNormLawFirmAPI"),
            "caseCountAnalyticsByOpposingNormPartyAPI": obj.get("caseCountAnalyticsByOpposingNormPartyAPI")
        })
        return _obj


