# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.attorney_analytics_api import AttorneyAnalyticsAPI
from unicourt.model.bar_record import BarRecord
from unicourt.model.case_analytics_api import CaseAnalyticsAPI
from unicourt.model.similar_norm_attorney import SimilarNormAttorney
from typing import Optional, Set
from typing_extensions import Self

class NormAttorney(BaseModel):
    """
    Norm Attorney
    """ # noqa: E501
    object: Optional[Annotated[str, Field(strict=True, max_length=12)]] = 'NormAttorney'
    norm_attorney_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, alias="normAttorneyId")
    name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = None
    first_name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, alias="firstName")
    middle_name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, alias="middleName")
    last_name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, alias="lastName")
    case_search_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="caseSearchAPI")
    case_analytics_api: Optional[CaseAnalyticsAPI] = Field(default=None, alias="caseAnalyticsAPI")
    has_associated_public_data: Optional[StrictBool] = Field(default=None, alias="hasAssociatedPublicData")
    bar_record_array: Optional[List[BarRecord]] = Field(default=None, alias="barRecordArray")
    attorney_analytics_api: Optional[AttorneyAnalyticsAPI] = Field(default=None, alias="attorneyAnalyticsAPI")
    similar_norm_attorney_array: Optional[List[SimilarNormAttorney]] = Field(default=None, alias="similarNormAttorneyArray")
    __properties: ClassVar[List[str]] = ["object", "normAttorneyId", "name", "firstName", "middleName", "lastName", "caseSearchAPI", "caseAnalyticsAPI", "hasAssociatedPublicData", "barRecordArray", "attorneyAnalyticsAPI", "similarNormAttorneyArray"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NormAttorney from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of case_analytics_api
        if self.case_analytics_api:
            _dict['caseAnalyticsAPI'] = self.case_analytics_api.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in bar_record_array (list)
        _items = []
        if self.bar_record_array:
            for _item in self.bar_record_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['barRecordArray'] = _items
        # override the default output from pydantic by calling `to_dict()` of attorney_analytics_api
        if self.attorney_analytics_api:
            _dict['attorneyAnalyticsAPI'] = self.attorney_analytics_api.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in similar_norm_attorney_array (list)
        _items = []
        if self.similar_norm_attorney_array:
            for _item in self.similar_norm_attorney_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['similarNormAttorneyArray'] = _items
        # set to None if middle_name (nullable) is None
        # and model_fields_set contains the field
        if self.middle_name is None and "middle_name" in self.model_fields_set:
            _dict['middleName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NormAttorney from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'NormAttorney',
            "normAttorneyId": obj.get("normAttorneyId"),
            "name": obj.get("name"),
            "firstName": obj.get("firstName"),
            "middleName": obj.get("middleName"),
            "lastName": obj.get("lastName"),
            "caseSearchAPI": obj.get("caseSearchAPI"),
            "caseAnalyticsAPI": CaseAnalyticsAPI.from_dict(obj["caseAnalyticsAPI"]) if obj.get("caseAnalyticsAPI") is not None else None,
            "hasAssociatedPublicData": obj.get("hasAssociatedPublicData"),
            "barRecordArray": [BarRecord.from_dict(_item) for _item in obj["barRecordArray"]] if obj.get("barRecordArray") is not None else None,
            "attorneyAnalyticsAPI": AttorneyAnalyticsAPI.from_dict(obj["attorneyAnalyticsAPI"]) if obj.get("attorneyAnalyticsAPI") is not None else None,
            "similarNormAttorneyArray": [SimilarNormAttorney.from_dict(_item) for _item in obj["similarNormAttorneyArray"]] if obj.get("similarNormAttorneyArray") is not None else None
        })
        return _obj


