# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from unicourt.model.case_analytics_api import CaseAnalyticsAPI
from unicourt.model.law_firm_analytics_api import LawFirmAnalyticsAPI
from unicourt.model.norm_organization import NormOrganization
from typing import Optional, Set
from typing_extensions import Self

class NormLawFirm(BaseModel):
    """
    Schema for Norm Law Firm containing Organization sub-field.
    """ # noqa: E501
    object: Optional[Annotated[str, Field(strict=True, max_length=11)]] = 'NormLawFirm'
    norm_law_firm_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, alias="normLawFirmId")
    name: Optional[Annotated[str, Field(strict=True, max_length=500)]] = None
    case_search_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="caseSearchAPI")
    case_analytics_api: Optional[CaseAnalyticsAPI] = Field(default=None, alias="caseAnalyticsAPI")
    norm_organization_data: Optional[NormOrganization] = Field(default=None, alias="normOrganizationData")
    law_firm_analytics_api: Optional[LawFirmAnalyticsAPI] = Field(default=None, alias="lawFirmAnalyticsAPI")
    __properties: ClassVar[List[str]] = ["object", "normLawFirmId", "name", "caseSearchAPI", "caseAnalyticsAPI", "normOrganizationData", "lawFirmAnalyticsAPI"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NormLawFirm from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of case_analytics_api
        if self.case_analytics_api:
            _dict['caseAnalyticsAPI'] = self.case_analytics_api.to_dict()
        # override the default output from pydantic by calling `to_dict()` of norm_organization_data
        if self.norm_organization_data:
            _dict['normOrganizationData'] = self.norm_organization_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of law_firm_analytics_api
        if self.law_firm_analytics_api:
            _dict['lawFirmAnalyticsAPI'] = self.law_firm_analytics_api.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NormLawFirm from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'NormLawFirm',
            "normLawFirmId": obj.get("normLawFirmId"),
            "name": obj.get("name"),
            "caseSearchAPI": obj.get("caseSearchAPI"),
            "caseAnalyticsAPI": CaseAnalyticsAPI.from_dict(obj["caseAnalyticsAPI"]) if obj.get("caseAnalyticsAPI") is not None else None,
            "normOrganizationData": NormOrganization.from_dict(obj["normOrganizationData"]) if obj.get("normOrganizationData") is not None else None,
            "lawFirmAnalyticsAPI": LawFirmAnalyticsAPI.from_dict(obj["lawFirmAnalyticsAPI"]) if obj.get("lawFirmAnalyticsAPI") is not None else None
        })
        return _obj


