# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PACERSearchPageInfo(BaseModel):
    """
    PACERSearchPageInfo
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=19, strict=True, max_length=19)]] = Field(default='PACERSearchPageInfo', description="Name of the object")
    number: Optional[StrictInt] = Field(default=None, description="Current Page number.")
    size: Optional[StrictInt] = Field(default=None, description="Number of results obtained in a page..")
    total_pages: Optional[StrictInt] = Field(default=None, description="Total pages of data available.", alias="totalPages")
    total_elements: Optional[StrictInt] = Field(default=None, description="Total number of records available", alias="totalElements")
    number_of_elements: Optional[StrictInt] = Field(default=None, description="Number of records returned.", alias="numberOfElements")
    first: Optional[StrictBool] = Field(default=None, description="Indicates if the current page is the first page.")
    last: Optional[StrictBool] = Field(default=None, description="Indicates if the current page is the last page.")
    __properties: ClassVar[List[str]] = ["object", "number", "size", "totalPages", "totalElements", "numberOfElements", "first", "last"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PACERSearchPageInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PACERSearchPageInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'PACERSearchPageInfo',
            "number": obj.get("number"),
            "size": obj.get("size"),
            "totalPages": obj.get("totalPages"),
            "totalElements": obj.get("totalElements"),
            "numberOfElements": obj.get("numberOfElements"),
            "first": obj.get("first"),
            "last": obj.get("last")
        })
        return _obj


