# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from unicourt.model.bar_record_preview import BarRecordPreview
from typing import Optional, Set
from typing_extensions import Self

class SimilarNormAttorney(BaseModel):
    """
    SimilarNormAttorney
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=19, strict=True, max_length=19)]] = 'SimilarNormAttorney'
    norm_attorney_id: Optional[Annotated[str, Field(min_length=18, strict=True, max_length=18)]] = Field(default=None, alias="normAttorneyId")
    norm_attorney_api: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="normAttorneyAPI")
    name: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=500)]] = None
    norm_attorney_similarity_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="normAttorneySimilarityScore")
    bar_record_preview_array: Optional[List[BarRecordPreview]] = Field(default=None, alias="barRecordPreviewArray")
    __properties: ClassVar[List[str]] = ["object", "normAttorneyId", "normAttorneyAPI", "name", "normAttorneySimilarityScore", "barRecordPreviewArray"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SimilarNormAttorney from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in bar_record_preview_array (list)
        _items = []
        if self.bar_record_preview_array:
            for _item in self.bar_record_preview_array:
                if _item:
                    _items.append(_item.to_dict())
            _dict['barRecordPreviewArray'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SimilarNormAttorney from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'SimilarNormAttorney',
            "normAttorneyId": obj.get("normAttorneyId"),
            "normAttorneyAPI": obj.get("normAttorneyAPI"),
            "name": obj.get("name"),
            "normAttorneySimilarityScore": obj.get("normAttorneySimilarityScore"),
            "barRecordPreviewArray": [BarRecordPreview.from_dict(_item) for _item in obj["barRecordPreviewArray"]] if obj.get("barRecordPreviewArray") is not None else None
        })
        return _obj


