# coding: utf-8

"""
    UniCourt Enterprise APIs

    <button><a href=\"/developers/enterpriseapi/api/download/UniCourt-Enterprise-API-Spec.yaml\" >Download UniCourt Enterprise APIs Specification</a></button> 

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class SourceCauseOfAction(BaseModel):
    """
    Source Cause of Action data from the source site.
    """ # noqa: E501
    object: Optional[Annotated[str, Field(min_length=19, strict=True, max_length=19)]] = Field(default='SourceCauseOfAction', description="Name of the object")
    is_visible: Optional[StrictBool] = Field(default=None, description="Signifies if the cause of action is currently isVisible or not for the case.", alias="isVisible")
    source_cause_of_action_raw: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, description="Raw Cause of Action data from the source site.", alias="sourceCauseOfActionRaw")
    source_cause_of_action: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(default=None, description="Cause of Action data from the source site.", alias="sourceCauseOfAction")
    source_statute: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(default=None, description="Statute of a Cause of Action.", alias="sourceStatute")
    first_fetch_date: Optional[Annotated[str, Field(min_length=25, strict=True, max_length=25)]] = Field(default=None, description="When this Cause of Action was first fetched from the court site.", alias="firstFetchDate")
    last_fetch_date: Optional[Annotated[str, Field(min_length=25, strict=True, max_length=25)]] = Field(default=None, description="When this Cause of Action was last fetched from the court site.", alias="lastFetchDate")
    __properties: ClassVar[List[str]] = ["object", "isVisible", "sourceCauseOfActionRaw", "sourceCauseOfAction", "sourceStatute", "firstFetchDate", "lastFetchDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SourceCauseOfAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if source_cause_of_action_raw (nullable) is None
        # and model_fields_set contains the field
        if self.source_cause_of_action_raw is None and "source_cause_of_action_raw" in self.model_fields_set:
            _dict['sourceCauseOfActionRaw'] = None

        # set to None if source_cause_of_action (nullable) is None
        # and model_fields_set contains the field
        if self.source_cause_of_action is None and "source_cause_of_action" in self.model_fields_set:
            _dict['sourceCauseOfAction'] = None

        # set to None if source_statute (nullable) is None
        # and model_fields_set contains the field
        if self.source_statute is None and "source_statute" in self.model_fields_set:
            _dict['sourceStatute'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SourceCauseOfAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object") if obj.get("object") is not None else 'SourceCauseOfAction',
            "isVisible": obj.get("isVisible"),
            "sourceCauseOfActionRaw": obj.get("sourceCauseOfActionRaw"),
            "sourceCauseOfAction": obj.get("sourceCauseOfAction"),
            "sourceStatute": obj.get("sourceStatute"),
            "firstFetchDate": obj.get("firstFetchDate"),
            "lastFetchDate": obj.get("lastFetchDate")
        })
        return _obj


